
GLvoid BuildFontBitmap(GLvoid)					// Build Our Bitmap Font
{
	HFONT	font;						// Windows Font ID

	baseflat = glGenLists(256);					// Storage For 256 Characters

	font = CreateFont(	-.5,				// Height Of Font
				0,				// Width Of Font
				0,				// Angle Of Escapement
				0,				// Orientation Angle
				FW_BOLD,			// Font Weight
				FALSE,				// Italic
				FALSE,				// Underline
				FALSE,				// Strikeout
				ANSI_CHARSET,			// Character Set Identifier
				OUT_TT_PRECIS,			// Output Precision
				CLIP_DEFAULT_PRECIS,		// Clipping Precision
				ANTIALIASED_QUALITY,		// Output Quality
				FF_DONTCARE|DEFAULT_PITCH,	// Family And Pitch
                                "Arial");//"Arial");
			      //	"Courier New");
	SelectObject(hDC, font);				// Selects The Font We Created ( NEW )

/*wglUseFontOutlines(	hDC,				// Select The Current DC
				0,				// Starting Character
				255,				// Number Of Display Lists To Build
				base,				// Starting Display Lists
				0.0f,				// Deviation From The True Outlines
				1,				// Font Thickness In The Z Direction
				WGL_FONT_POLYGONS,		// Use Polygons, Not Lines
				gmf);				// Address Of Buffer To Recieve Data
*/
	wglUseFontBitmaps(hDC, 32, 96, baseflat);
}



GLvoid BuildFont(GLvoid)					// Build Our Bitmap Font
{
	HFONT	font;						// Windows Font ID

	base = glGenLists(256);					// Storage For 256 Characters

	font = CreateFont(	-.5,				// Height Of Font
				0,				// Width Of Font
				0,				// Angle Of Escapement
				0,				// Orientation Angle
				FW_BOLD,			// Font Weight
				FALSE,				// Italic
				FALSE,				// Underline
				FALSE,				// Strikeout
				ANSI_CHARSET,			// Character Set Identifier
				OUT_TT_PRECIS,			// Output Precision
				CLIP_DEFAULT_PRECIS,		// Clipping Precision
				ANTIALIASED_QUALITY,		// Output Quality
				FF_DONTCARE|DEFAULT_PITCH,	// Family And Pitch
                                "Arial");
			      //	"Courier New");
	SelectObject(hDC, font);				// Selects The Font We Created ( NEW )

wglUseFontOutlines(	hDC,				// Select The Current DC
				0,				// Starting Character
				255,				// Number Of Display Lists To Build
				base,				// Starting Display Lists
				0.0f,				// Deviation From The True Outlines
				0.01f,				// Font Thickness In The Z Direction
				WGL_FONT_POLYGONS,		// Use Polygons, Not Lines
				gmf);				// Address Of Buffer To Recieve Data
}

GLvoid KillFont(GLvoid)
{
 	glDeleteLists(base, 256);
}

GLvoid glPrint( string fmt, ...)
{

	float		length=0;				// Used To Find The Length Of The Text
	char		text[256];				// Holds Our String
	va_list		ap;					// Pointer To List Of Arguments
	if (fmt == "")					// If There's No Text
		return;						// Do Nothing
	va_start(ap, fmt);					// Parses The String For Variables
	    vsprintf(text, fmt.c_str(), ap);				// And Converts Symbols To Actual Numbers
	va_end(ap);						// Results Are Stored In Text

	for (unsigned int loop=0;loop<(strlen(text));loop++)	// Loop To Find Text Length
	{
		length+=gmf[text[loop]].gmfCellIncX;		// Increase Length By Each Characters Width
	}
	glTranslatef(0.0,0.0f,0.0f);			// Center Our Text On The Screen
	glPushAttrib(GL_LIST_BIT);				// Pushes The Display List Bits
	glListBase(base);					// Sets The Base Character to 0
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);	// Draws The Display List Text
	glPopAttrib();						// Pops The Display List Bits
}

GLvoid glPrintbitmapLEFT( string fmt, ...)
{

	float		length=0;				// Used To Find The Length Of The Text
	char		text[256];				// Holds Our String
	va_list		ap;					// Pointer To List Of Arguments
	if (fmt == "")					// If There's No Text
		return;						// Do Nothing
	va_start(ap, fmt);					// Parses The String For Variables
	    vsprintf(text, fmt.c_str(), ap);				// And Converts Symbols To Actual Numbers
	va_end(ap);						// Results Are Stored In Text

	for (unsigned int loop=0;loop<(strlen(text));loop++)	// Loop To Find Text Length
	{
		length+=gmf[text[loop]].gmfCellIncX;		// Increase Length By Each Characters Width
	}
	glPushAttrib(GL_LIST_BIT);				// Pushes The Display List Bits
	glListBase(baseflat - 32);					// Sets The Base Character to 0


        glRasterPos2f(0, 0);
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);	// Draws The Display List Text

	glPopAttrib();
}

GLvoid glPrintbitmapRIGHT( string fmt, ...)
{

	float		length=0;				// Used To Find The Length Of The Text
	char		text[256];				// Holds Our String
	va_list		ap;					// Pointer To List Of Arguments
	if (fmt == "")					// If There's No Text
		return;						// Do Nothing
	va_start(ap, fmt);					// Parses The String For Variables
	    vsprintf(text, fmt.c_str(), ap);				// And Converts Symbols To Actual Numbers
	va_end(ap);						// Results Are Stored In Text

	for (unsigned int loop=0;loop<(strlen(text));loop++)	// Loop To Find Text Length
	{
		length+=gmf[text[loop]].gmfCellIncX;		// Increase Length By Each Characters Width
	}
	glPushAttrib(GL_LIST_BIT);				// Pushes The Display List Bits
	glListBase(baseflat - 32);					// Sets The Base Character to 0

        glTranslatef(-length,0.0f,0.0f);
        glRasterPos2f(0, 0);
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);	// Draws The Display List Text

	glPopAttrib();
}

GLvoid glPrintcenterbitmap( string fmt, ...)
{

	float		length=0;				// Used To Find The Length Of The Text
	char		text[256];				// Holds Our String
	va_list		ap;					// Pointer To List Of Arguments
	if (fmt == "")					// If There's No Text
		return;						// Do Nothing
	va_start(ap, fmt);					// Parses The String For Variables
	    vsprintf(text, fmt.c_str(), ap);				// And Converts Symbols To Actual Numbers
	va_end(ap);						// Results Are Stored In Text

	for (unsigned int loop=0;loop<(strlen(text));loop++)	// Loop To Find Text Length
	{
		length+=gmf[text[loop]].gmfCellIncX;		// Increase Length By Each Characters Width
	}

	glPushAttrib(GL_LIST_BIT);				// Pushes The Display List Bits
	glListBase(baseflat - 32);					// Sets The Base Character to 0
        glRasterPos2f(-length/2, 0);
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);	// Draws The Display List Text
	glPopAttrib();
}

GLvoid glPrintcenter( string fmt, ...)
{

	float		length=0;				// Used To Find The Length Of The Text
	char		text[256];				// Holds Our String
	va_list		ap;					// Pointer To List Of Arguments
	if (fmt == "")					// If There's No Text
		return;						// Do Nothing
	va_start(ap, fmt);					// Parses The String For Variables
	    vsprintf(text, fmt.c_str(), ap);				// And Converts Symbols To Actual Numbers
	va_end(ap);						// Results Are Stored In Text

	for (unsigned int loop=0;loop<(strlen(text));loop++)	// Loop To Find Text Length
	{
		length+=gmf[text[loop]].gmfCellIncX;		// Increase Length By Each Characters Width
	}
	glTranslatef(-length/2,0.0f,0.0f);			// Center Our Text On The Screen
	glPushAttrib(GL_LIST_BIT);				// Pushes The Display List Bits
	glListBase(base);					// Sets The Base Character to 0
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);	// Draws The Display List Text
	glPopAttrib();						// Pops The Display List Bits
}

GLvoid glPrintLEFT( string fmt, ...)
{

	float		length=0;				// Used To Find The Length Of The Text
	char		text[256];				// Holds Our String
	va_list		ap;					// Pointer To List Of Arguments
	if (fmt == "")					// If There's No Text
		return;						// Do Nothing
	va_start(ap, fmt);					// Parses The String For Variables
	    vsprintf(text, fmt.c_str(), ap);				// And Converts Symbols To Actual Numbers
	va_end(ap);						// Results Are Stored In Text

	for (unsigned int loop=0;loop<(strlen(text));loop++)	// Loop To Find Text Length
	{
		length+=gmf[text[loop]].gmfCellIncX;		// Increase Length By Each Characters Width
	}
	glTranslatef(-length,0.0f,0.0f);			// Center Our Text On The Screen
	glPushAttrib(GL_LIST_BIT);				// Pushes The Display List Bits
	glListBase(base);					// Sets The Base Character to 0
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);	// Draws The Display List Text
	glPopAttrib();						// Pops The Display List Bits
}

GLvoid glPrintRIGHT( string fmt, ...)
{

	float		length=0;				// Used To Find The Length Of The Text
	char		text[256];				// Holds Our String
	va_list		ap;					// Pointer To List Of Arguments
	if (fmt == "")					// If There's No Text
		return;						// Do Nothing
	va_start(ap, fmt);					// Parses The String For Variables
	    vsprintf(text, fmt.c_str(), ap);				// And Converts Symbols To Actual Numbers
	va_end(ap);						// Results Are Stored In Text

	for (unsigned int loop=0;loop<(strlen(text));loop++)	// Loop To Find Text Length
	{
		length+=gmf[text[loop]].gmfCellIncX;		// Increase Length By Each Characters Width
	}
	//glTranslatef(-length,0.0f,0.0f);			// Center Our Text On The Screen
	glPushAttrib(GL_LIST_BIT);				// Pushes The Display List Bits
	glListBase(base);					// Sets The Base Character to 0
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);	// Draws The Display List Text
	glPopAttrib();						// Pops The Display List Bits
}
