
void stopall()
{
if (SOUND)
g_pPerformance->Stop(NULL, NULL, 0 ,DMUS_SEGF_BEAT  );
}

void playAi(String FileName)
{
if (SOUND)
{
TStringConverter<char> T;
if( FAILED( g_pLoader->LoadObjectFromFile( CLSID_DirectMusicSegment,
                                               IID_IDirectMusicSegment8,
                                                T.AnsiToWide(FileName.c_str()),
                                               (LPVOID*) &g_pSegment ) ) )
    {
    }
    g_pSegment->Download( g_pPerformance);
g_pPerformance->PlaySegmentEx( g_pSegment, NULL, NULL, DMUS_SEGF_SECONDARY | DMUS_SEGF_DEFAULT, 0, NULL, NULL,  g_p3DAudiopathAi);
}
}

void playUs(String FileName)
{
if (SOUND)
{
TStringConverter<char> T;
if( FAILED( g_pLoader->LoadObjectFromFile( CLSID_DirectMusicSegment,
                                               IID_IDirectMusicSegment8,
                                                T.AnsiToWide(FileName.c_str()),
                                               (LPVOID*) &g_pSegment ) ) )
    {
    }
    g_pSegment->Download( g_pPerformance);
g_pPerformance->PlaySegmentEx( g_pSegment, NULL, NULL, DMUS_SEGF_SECONDARY | DMUS_SEGF_DEFAULT, 0, NULL, NULL,  g_p3DAudiopathUs);
}
}
void playUSAGAIN()
{
if (SOUND)
g_pPerformance->PlaySegmentEx( g_pSegment, NULL, NULL, DMUS_SEGF_SECONDARY | DMUS_SEGF_DEFAULT, 0, NULL, NULL,  g_p3DAudiopathUs);
}

void SoundSetup()
{
 CoInitialize(NULL);

 CoCreateInstance( CLSID_DirectMusicLoader, NULL, CLSCTX_INPROC,
                      IID_IDirectMusicLoader8, (void**)&g_pLoader );

 CoCreateInstance( CLSID_DirectMusicPerformance, NULL, CLSCTX_INPROC,
                      IID_IDirectMusicPerformance8, (void**)&g_pPerformance );

 g_pPerformance->InitAudio( NULL, NULL, NULL,
                               DMUS_APATH_DYNAMIC_STEREO, 64,
                               DMUS_AUDIOF_ALL, NULL );

 g_pPerformance->CreateStandardAudioPath(
    DMUS_APATH_DYNAMIC_3D,      // Path type.
    64,                         // Number of performance channels.
    false,                       // Activate now.
    &g_p3DAudiopathUs);               // Pointer that receives audiopath.

g_p3DAudiopathUs->SetVolume(-3210,0);
g_p3DAudiopathUs->Activate(true);

 g_pPerformance->CreateStandardAudioPath(
    DMUS_APATH_DYNAMIC_3D,      // Path type.
    64,                         // Number of performance channels.
    true,                       // Activate now.
    &g_p3DAudiopathAi);               // Pointer that receives audiopath.

g_p3DAudiopathAi->GetObjectInPath( 0, DMUS_PATH_BUFFER, 0, GUID_NULL, 0, IID_IDirectSound3DBuffer, (void**)&my3Dbuffer);
dsBuffer.dwSize = sizeof(DS3DBUFFER);
my3Dbuffer->GetAllParameters(&dsBuffer);
dsBuffer.dwMode = DS3DMODE_HEADRELATIVE;
my3Dbuffer->SetAllParameters(&dsBuffer, DS3D_IMMEDIATE);
g_p3DAudiopathAi->GetObjectInPath( 0, DMUS_PATH_PRIMARY_BUFFER, 0, GUID_NULL, 0, IID_IDirectSound3DListener, (void**)&my3Dlistener);
dsListener.dwSize = sizeof(DS3DLISTENER);
my3Dlistener->GetAllParameters(&dsListener);
//SetPos
dsListener.vPosition.x=0;
dsListener.vPosition.y=0;
dsListener.vPosition.z=0;
my3Dlistener->SetAllParameters(&dsListener, DS3D_IMMEDIATE);
my3Dbuffer->SetPosition(0,0,0,DS3D_IMMEDIATE);

}

void reset()
{
if (SOUND)
{
g_p3DAudiopathUs->Activate(false);
g_p3DAudiopathUs->SetVolume(-3210,0);
g_p3DAudiopathUs->Activate(true);
}
}

Setaipos(float length, float angle)
{
if (SOUND)
my3Dbuffer->SetPosition(length*cos(DegToRad(angle)),0,-(length*sin(DegToRad(angle))),DS3D_IMMEDIATE);
}

