// THIS FILE CONTAINS GLOBAL VARIBLES USED BY INTIRE PROGRAM

HDC 		hDC=NULL;
HGLRC		hRC=NULL;
HWND		hWnd=NULL;
HINSTANCE	hInstance;
bool	active=TRUE;
bool	fullscreen=TRUE;
bool	keys[256];

LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
int InitGL(GLvoid);
int InitGLMini(GLvoid);
bool booted=false;
float MAX_SPEED=.9;
float SPEED_INCREASE_RATE=.00002;

clock_t start, end;
clock_t start2, end2;
clock_t Sstart, Send;
clock_t BEGIN, NOW;
clock_t StFIX, StFIXEND;
clock_t LOADFADE, LOADFADEE;
clock_t TEST1, TEST2;
clock_t SOUND1, SOUND2;

int FRAMES;int FRAMERATE;//NOT FUNCTIONAL
bool FRAMERATEDISPLAY=false;//NOT FUNCTIONAL

int XMODE, YMODE, COLORBIT;

bool MOUSERB=false;
bool MOUSELB=false;
POINT mpos;
GLfloat MOSROT;//0-45

GLYPHMETRICSFLOAT gmf[256];
GLuint	base;
GLuint	baseflat;
GLfloat	rot;

GLfloat DIAMETER;

typedef struct
{
	GLfloat x, y, z;
}
staa;

staa grid[100][2];
staa Sgrid[200];

staa virtualpoints;
GLfloat divistions;

int pass;
bool pass1;

GLuint textures[7];

//server data
POINT User, Other;

float scaninpersent;
int ROVOLUTION;


class DVector
{
public:
        GLfloat X, Y, Length, Rotation;//These varibles are used by functions to make things simple
        void SetAngle(float rotation);
        void Clear();
};

void DVector::SetAngle(float rotation)
{
Rotation=rotation;
X=Length*cos(DegToRad(rotation));
Y=Length*sin(DegToRad(rotation));
}

void DVector::Clear()
{
Length=0;
X=0;
Y=0;
}




typedef struct
{
	int A, B, C;
        int AB, BC, CA;
        int Smoothing;
}
star;

star Ufaces[50000];
staa Uvertexs[30000];
int UTFaces;

staa UvertexsC[300];

// Game play info
bool paused;
DVector mLoc, oLoc;
DVector  mVel, oVel;
staa  mVel2, oVel2;
GLfloat mLife, oLife;

string buffer;
string backbuffer;

bool NOTPLAYING=true;
int ROTATEonTime;
float EDGEHEIGHT=2;

bool camera=false;//View Computer camera, NOT FUNCTIONAL IN FIRST PERSON
bool RECORDDEMO=false;

ofstream RECORD;

int progress[4];

//GAME STATES
#define state_mainmenu 0
#define state_optionsmenu 2
#define state_playing 1
#define state_scorescreen 3
#define state_fadeloading 4
#define state_DEMO 5
#define state_P_fade 6
#define state_D_fade 8
#define state_P_fadein 9
#define state_D_fadein 10
#define state_MAINMENUfadeout 11
#define state_O_fade 12

int game_state=state_fadeloading;

//start at 0
int SCORE1=0;
int SCORE2=0;
int ROUNDS1=0;
int ROUNDS2=0;

int ROUND=0;//1-3 best 2 out of 3

int optionselected=0;//used for menus and stuff
float menuanimationcue=0;
bool RESUME=false;
bool nomoredemo=false;

//Demo buttons
bool VRB=false;
bool VLB=false;

TStringList *PLAYBACK = new TStringList;
int position;

float FADE;
float PeRsent;

int next;
bool HAVEIPLAYEDYET;

           
IDirectMusicLoader8*      g_pLoader               = NULL;
IDirectMusicPerformance8* g_pPerformance          = NULL;
IDirectMusicSegment8*     g_pSegment               = NULL;
IDirectMusicAudioPath*  g_p3DAudiopathUs           = NULL;
IDirectMusicAudioPath*  g_p3DAudiopathAi           = NULL;
IDirectSound3DBuffer* my3Dbuffer                   = NULL;
IDirectSound3DListener* my3Dlistener               = NULL;
                   
DS3DBUFFER dsBuffer;
DS3DLISTENER dsListener;

float TIMEBASE=0;
float RINGBASE=0;
bool done;
bool firstperson=false;
bool SOUND;

//---------------Timeing system

class framerate
{
public:
  float         targetfps;
  float         fps;
  LARGE_INTEGER tickspersecond;
  LARGE_INTEGER currentticks;
  LARGE_INTEGER framedelay;
	
  float         speedfactor;

  void          Init(float tfps);
  void          SetSpeedFactor();
};

void framerate::Init(float tfps)
{
  targetfps = tfps;
  QueryPerformanceCounter(&framedelay);
  QueryPerformanceFrequency(&tickspersecond);
}
void framerate::SetSpeedFactor()
{
  QueryPerformanceCounter(&tickspersecond);
  //This frame's length out of desired length
  speedfactor = (float)(currentticks.QuadPart-framedelay.QuadPart)/((float)tickspersecond.QuadPart/targetfps);
  if (speedfactor <= 0)
    speedfactor = 1;
  fps = targetfps/speedfactor;


  framedelay = currentticks;
}

framerate TimeUnit;
